% === lpiircomb2.m ===      ===
% Authors: P.Dutilleux, U. Zolzer, A. Prodeus
 
Fs = 8000;                        %    
T = 1; N = T*Fs;                   %    
x=zeros(N,1);x(1)=1;               % unit impulse signal of length N
%x = wavread('audiobook');          %  
%N = length(x);                     % -   
t = 0:1/Fs:1/Fs*(N-1);             %   
tau = 0.1; M = tau*Fs;             %   
g=0.5;
df = 3000;                          % .   
beta = df/Fs;                      % . 
a0 = beta;
a1 = 0;
b1 = 1-beta;
yhold=0;
Delayline=zeros(M,1); % memory allocation for length M
for n=1:length(x);
yh(n)=a0*Delayline(M)+b1*yhold;          % 1st-order difference equation
yhold=yh(n);
y(n)=x(n)+g*yh(n);
Delayline=[y(n);Delayline(1:M-1)];
end;
 
figure; plot(t,y);                   %   ()
xlabel(', '); ylabel(''); 
title('');
 
% 
[H,f] = freqz(y,1,10000,Fs);
figure; plot(f,20*log10(abs(H)));
xlabel(', '); ylabel(', '); 
title('');
 
% 
[P,f] = phasez(y,1,10000,Fs);
P = unwrap(P);
figure; plot(f,P/pi*180);
xlabel(', '); ylabel(', '); 
title('');
 
%  
df = f(2)-f(1);
tau = -diff(P)/(2*pi*df);
figure; plot(f(1:end-1),tau);
xlabel(', '); ylabel(' , '); 
title(' ');
