% === schroeder_rever.m === M.Schroeder reverberator ===
x = zeros(1,2500); x(1) = 1;     % Create an impulse
A = zeros(1,100);                     % Delay line and read position
Adelay=40;
ir = zeros(1,2500);                    % Output vector
g=0.5; % Feedback gain

% === Comb-allpass filtering ===
for n = 1:length(ir)
tmp = A(Adelay) + x(n)*(-g);
A = [(tmp*g + x(n))' A(1:length(A)-1)];
ir(n) = tmp;
end
plot(ir)                      % Plot the filtering result
