% === schroeder_rever_2.m === M.Schroeder reverberator ===
x = zeros(1,5000); x(1) = 1;     % Create an impulse
A = zeros(1,200);          % Delay line and read position
Adelay=80;
ir = zeros(1,5000);                    % Output vector
g=0.9; % Feedback gain

% === Comb-allpass filtering ===
for n = 1:length(ir)
tmp = A(Adelay) + x(n)*(-g);
A = [(tmp*g + x(n))' A(1:length(A)-1)];
ir(n) = tmp;
end
plot(ir)                      % Plot the filtering result
